# encoding: utf-8
#
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

# require 'rubygems' unless defined?(Gem)
# require 'bundler/setup'
# Bundler.require :default

module Tomte

  LIBRARY =  File.expand_path('..', __FILE__)
  $:.unshift LIBRARY

  require 'tomte/version'
  require 'wml/compat'

  require 'active_support'
  require 'active_support/dependencies/autoload'
  require 'active_support/core_ext'
  require 'json'
  require 'bson'

  extend ActiveSupport::Autoload

  autoload :Configuration,      'tomte/configuration'
  autoload :BlankSlate,         'tomte/blankslate'
  autoload :Logging,            'tomte/logging'
  autoload :Logger,             'tomte/logger'

  require 'tomte/debug'

  Config = Configuration.new :root => :core

  def self.configure! *args
    Config.configure! *args
    $logger = nil # reset logger after loading the configuration, allow debugging output
  end

  def self.config
    Config
  end

  def self.env
    Config.core[:environment]
  end



  def self.logger
#    Thread.current[:_logger] ||=
    $logger ||=
        Tomte::Logger.setup!({ :profile => Config.core[:log_profile],
                               :log_path => Config.core[:log_path],
                               :log_level => Config.core[:log_level]
                             }.merge(config.local))

  end

  require 'tomte/core'
  require 'tomte/utils'
end
