# encoding: UTF-8
module Tomte
  module Document
    module Extensions
      module Date
        def to_tomte(value)
          if value.nil? || value == ''
            nil
          else
            date = value.is_a?(::Date) || value.is_a?(::Time) ? value : ::Date.parse(value.to_s)
            ::Time.utc(date.year, date.month, date.day)
          end
        rescue
          nil
        end

        def from_tomte(value)
          value.to_date if value.present?
        end
      end
    end
  end
end

class Date
  extend Tomte::Document::Extensions::Date
end