# encoding: UTF-8
module Tomte
  module Document
    module Extensions
      module ObjectId
        def to_tomte(value)
          if value.nil? || (value.respond_to?(:empty?) && value.empty?)
            nil
          elsif value.instance_of?(BSON::ObjectId )
            value
          elsif value.instance_of?(Tomte::ObjectId )
            BSON::ObjectId.new(value.to_a)
          else
            if BSON::ObjectId.legal?(value.to_s)
              BSON::ObjectId.from_string(value.to_s)
            else
              value
            end
          end
        end

        def from_tomte(value)
          if value.instance_of?(Tomte::ObjectId)
            value
          elsif value.instance_of?(::BSON::ObjectId)
            Tomte::ObjectId.new(value.to_a)
          else
            value
          end
        end
      end
    end
  end

  class ObjectId
    extend Tomte::Document::Extensions::ObjectId
  end

end



class BSON::ObjectId
  alias_method :original_to_json, :to_json

  extend Tomte::Document::Extensions::ObjectId

  def as_json(options=nil)
    to_s
  end

  def to_json(options = nil)
    as_json.to_json
  end
end
