# encoding: UTF-8
module Tomte
  module Document
    module Extensions
      module Time
        def to_tomte(value)
          if value.nil? || value == ''
            nil
          else
            time_class = ::Time.try(:zone) || ::Time
            time = value.is_a?(::Time) ? value : time_class.parse(value.to_s)
            # strip milliseconds as Ruby does micro and bson does milli and rounding rounded wrong
            ::Time.at(time.to_f).utc if time
          end
        end

        def from_tomte(value)
          if value and zone = ::Time.try(:zone)
            value.in_time_zone(::Time.zone)
          else
            value
          end
        end
      end
    end
  end
end

class Time
  extend Tomte::Document::Extensions::Time
end

class ActiveSupport::TimeWithZone
  extend Tomte::Document::Extensions::Time
end